/*
 * Partially implemented disassembler for Samsung SSP160x processors
 * (C) Copyright 2007-2008, Grazvydas "notaz" Ignotas
 */

#include "ssp.hpp"

instruc_t Instructions[] =
{
  { "unkn",  0 },      // Unknown Operation
  { "nop",   0 },

  // OP a, s; OP a, adr
  { "ld",    CF_CHG1|CF_USE2 },
  { "sub",   CF_CHG1|CF_USE2 },
  { "cmp",   CF_CHG1|CF_USE2 },
  { "add",   CF_CHG1|CF_USE2 },
  { "and",   CF_CHG1|CF_USE2 },
  { "or",    CF_CHG1|CF_USE2 },
  { "eor",   CF_CHG1|CF_USE2 },

  // OP a, imm
  { "ldi",   CF_CHG1|CF_USE2 },
  { "subi",  CF_CHG1|CF_USE2 },
  { "cmpi",  CF_CHG1|CF_USE2 },
  { "addi",  CF_CHG1|CF_USE2 },
  { "andi",  CF_CHG1|CF_USE2 },
  { "ori",   CF_CHG1|CF_USE2 },
  { "eori",  CF_CHG1|CF_USE2 },

  // OP simm
  { "subi",  CF_USE1 },
  { "cmpi",  CF_USE1 },
  { "addi",  CF_USE1 },
  { "andi",  CF_USE1 },
  { "ori",   CF_USE1 },
  { "eori",  CF_USE1 },

  { "call",  CF_USE1|CF_USE2|CF_CALL },
  { "bra",   CF_USE1|CF_USE2 },
  { "ld",    CF_CHG1|CF_USE2 },		// ld PC, imm
  { "ret",   CF_STOP },

  { "mod",   CF_USE1|CF_USE2 },
  { "mpys",  CF_CHG1|CF_USE1|CF_USE2|CF_USE3 },
  { "mpya",  CF_CHG1|CF_USE1|CF_USE2|CF_USE3 },
  { "mld",   CF_CHG1|CF_USE1|CF_USE2|CF_USE3 },
  { "mset",  CF_CHG1|CF_USE2|CF_USE3 },
};


